# Magic Compass

Teleport system for Minetest (yes, GUI aspect will be improved)  
  
<a href="https://liberapay.com/Zughy/"><img src="https://i.imgur.com/4B2PxjP.png" alt="Support my work"/></a>  

<img src="https://content.minetest.net/uploads/pt68Gn7BjL.png"/>  

### How to use it
Look for the "Magic Compass" item in your inventory, put it in your hand and left click it to open the locations menu

### Customisation
Every icon in the menu is a location. Locations must be declared in a .txt document inside the `locations` folder like so:
```
Red Forest                  -- the name you want to show in the menu when hovering the icon
magiccompass_redforest.png  -- the associated texture
-3.5, 5.0, -20.5            -- where the player will be teleported
5			    -- (optional) cooldown before being able to use it again. Leave empty or put -1 for none
interact, mygdr_lv10        -- (optional) privileges required in order to use it. Use ", " to separate them or it won't work
HIDE			    -- (optional) whether to hide the icon to players who don't have the required privileges
```
The file name is important too, as it must start with a number followed by an underscore like `5_whatever name.txt`.  
The number indicates the position of the associated item in the grid (which scales according to the highest number declared), and empty spaces are generated automatically if the numbers of the items don't represent a full sequence.  

Also, don't forget to edit `config.txt` to suit your needs!

### Want to help?
Feel free to:
* open an [issue](https://gitlab.com/zughy-friends-minetest/magic-compass/-/issues)
* submit a merge request. In this case, PLEASE, do follow milestones and my [coding guidelines](https://cryptpad.fr/pad/#/2/pad/view/-l75iHl3x54py20u2Y5OSAX4iruQBdeQXcO7PGTtGew/embed/). I won't merge features for milestones that are different from the upcoming one (if it's declared), nor messy code
* contact me on the [Minetest Forum](https://forum.minetest.net/memberlist.php?mode=viewprofile&u=26472)
